(*
    #################################################################

    ړI    :   ۂ\Ȃt@Cǂݍ

        :   2003/12/23@쐬
                2004/01/17@Xbh

    l    :   ǂݍ݂̓rLZ\
                ̎_܂ł̓ǂݍݓe߂

    #################################################################
*)

unit LoadFile;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, _Base, StdCtrls, Gauges, Buttons, ExtCtrls;

type
  TLoadFileForm = class(T_BaseForm)
    Gauge: TGauge;
    LblFileName: TLabel;
    LblTime01: TLabel;
    BtnAbort: TBitBtn;
    ImgIcon: TImage;
    LblSize01: TLabel;
    BtnPause: TBitBtn;
    LblSpeed: TLabel;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    LblTime02: TLabel;
    LblSize02: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure BtnAbortClick(Sender: TObject);
    procedure BtnPauseClick(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
  private
    FStartCount : Cardinal;
    FChildThread: TThread;
  public
    procedure   OnProgress(const AFullSize, ALoadedSize: integer);
    procedure   OnFinished();
  published
    property    ChildThread: TThread write FChildThread;
  end;

function    LoadFromLocalFile(AFileName: string; AStrings: TStrings): Boolean;
function    LoadFromNetFile(AUrl, AUserAgent: string; AStream: TMemoryStream): Boolean;

implementation

uses
    Wininet;

(*
    =================================================================
    ܂悤ɕ\
    -----------------------------------------------------------------
    [Borland]\CBuilder5\Source\Vcl\filectrl.pas
    =================================================================
*)
procedure CutFirstDirectory(var S: TFileName);
var
  Root: Boolean;
  P: Integer;
begin
  if S = '\' then
    S := ''
  else
  begin
    if S[1] = '\' then
    begin
      Root := True;
      Delete(S, 1, 1);
    end
    else
      Root := False;
    if S[1] = '.' then
      Delete(S, 1, 4);
    P := AnsiPos('\',S);
    if P <> 0 then
    begin
      Delete(S, 1, P);
      S := '...\' + S;
    end
    else
      S := '';
    if Root then
      S := '\' + S;
  end;
end;

(*
    =================================================================
    ܂悤ɕ\({)
    -----------------------------------------------------------------
    [Borland]\CBuilder5\Source\Vcl\filectrl.pas
    =================================================================
*)
function MinimizeName(const Filename: TFileName; Canvas: TCanvas;
  MaxLen: Integer): TFileName;
var
  Drive: TFileName;
  Dir: TFileName;
  Name: TFileName;
begin
  Result := FileName;
  Dir := ExtractFilePath(Result);
  Name := ExtractFileName(Result);

  if (Length(Dir) >= 2) and (Dir[2] = ':') then
  begin
    Drive := Copy(Dir, 1, 2);
    Delete(Dir, 1, 2);
  end
  else
    Drive := '';
  while ((Dir <> '') or (Drive <> '')) and (Canvas.TextWidth(Result) > MaxLen) do
  begin
    if Dir = '\...\' then
    begin
      Drive := '';
      Dir := '...\';
    end
    else if Dir = '' then
      Drive := ''
    else
      CutFirstDirectory(Dir);
    Result := Drive + Dir + Name;
  end;
end;


(*
    ---------------------------------------------------------------------------
    ~bXXX:XX:XX XXXZ
    ---------------------------------------------------------------------------
*)
function    MilliSecToTimeStr(AMilliSec: Cardinal): string;
var
    TempTix: Cardinal;
    Hour, Minute, Second, MSecond: integer;
begin
    TempTix := AMilliSec;
    //  ~bvZ
    MSecond := TempTix mod 1000;
    Dec(TempTix, MSecond);
    TempTix := TempTix div 1000;
    //  bvZ
    Second := TempTix mod 60;
    Dec(TempTix, Second);
    TempTix := TempTix div 60;
    //  vZ
    Minute := TempTix mod 60;
    Dec(TempTix, Minute);
    TempTix := TempTix div 60;
    //  ԌvZ
    Hour := TempTix mod 60;
    //  
    Result := Format('%3d:%2.2d:%2.2d', [Hour, Minute, Second]);
//    Result := Format('%3d:%2.2d:%2.2d %3.3d', [Hour, Minute, Second, MSecond]);
end;

(*
    ===========================================================================
    t@CǍXbhx[X
    ===========================================================================
*)
type
    TOnMessage = procedure(const AMsg: string) of object;
    TOnProgress = procedure(const AFullSize, ALoadedSize: integer) of object;
    TOnFinished = procedure() of object;

    TLoaderThread = class(TThread)
    private

    protected
        FDone       : Boolean;
        FNoError    : Boolean;

        FMessage    : string;
        FFullSize   : LongInt;
        FLoadedSize : Cardinal;

        FOnMessage  : TOnMessage;
        FOnProgress : TOnProgress;
        FOnFinished : TOnFinished;

        procedure   CheckDoMessage(const AMsg: string);
        procedure   CheckDoProgress(const AFullSize, ALoadedSize: integer);
        procedure   CheckDoFinished();

        procedure   DoMessage();
        procedure   DoProgress();
        procedure   DoFinished();
    public

    published
        property    Done        : Boolean read FDone;
        property    OnMessage   : TOnMessage write FOnMessage;
        property    OnProgress  : TOnProgress write FOnProgress;
        property    OnFinished  : TOnFinished write FOnFinished;
    end;

procedure   TLoaderThread.DoMessage();
begin
    FOnMessage(FMessage);
end;

procedure   TLoaderThread.DoProgress();
begin
    FOnProgress(FFullSize, FLoadedSize);
end;

procedure   TLoaderThread.DoFinished();
begin
    FOnFinished();
end;

procedure   TLoaderThread.CheckDoMessage(const AMsg: string);
begin
    if Assigned(FOnMessage) then
    begin
        FMessage := AMsg;
        Synchronize(DoMessage);
    end;
end;

procedure   TLoaderThread.CheckDoProgress(const AFullSize, ALoadedSize: integer);
begin
    if Assigned(FOnProgress) then
    begin
        FFullSize := AFullSize;
        FLoadedSize := ALoadedSize;
        Synchronize(DoProgress);
    end;
end;

procedure   TLoaderThread.CheckDoFinished();
begin
    if Assigned(FOnFinished) then Synchronize(DoFinished);
end;

(*
    ===========================================================================
    [Jt@CǍXbh
    ===========================================================================
*)
type
    TLocalLoaderThread = class(TLoaderThread)
    private
        FFileName   : string;
        FStrings    : TStrings;
    public
        constructor Create(AFileName: string; AStrings: TStrings);
        procedure   Execute; override;
    end;

constructor TLocalLoaderThread.Create(AFileName: string; AStrings: TStrings);
begin
    FFileName := AFileName;
    FStrings := AStrings;
    inherited Create(true);
end;

procedure   TLocalLoaderThread.Execute;
const
    PROGRESS_INTERVAL = 200;
var
    PreFileMode: Byte;
    F: TextFile;
    S: string;
    SearchRec: TSearchRec;
    FileSize, LineSize, SumSize: Integer;
    Counter: integer;
begin
    //  O
    FDone := false;
    FNoError := false;
    Counter := 0;

    //  ǂݍݐ̃XgNA
    FStrings.Clear;
    //  t@C[hobNAbv
    PreFileMode := FileMode;
    //  t@CTCYv
    FindFirst(FFileName, faAnyFile, SearchRec);
    try
        //  t@CTCY擾
        FileSize := SearchRec.Size;
        //  Ǎς݃TCY
        SumSize := 0;
        //  i
        CheckDoProgress(FileSize, SumSize);
        //  JS}
        AssignFile(F, FFileName);
        //  t@C[hǂݏopɐݒ肷
        FileMode := 0;
        //  ܂?
        try
            //  V
            Reset(F);
            //  ŏIs܂œǂݍ
            while (not EOF(F)) and (not Terminated) do
            begin
                //  1sǂݍ
                Readln(F, S);
                //  Xgɒǉ
                FStrings.Add(S);
                //  ǂݍ񂾍s̃TCY擾(+2__CRLF̃TCY)
                LineSize := Length(S) + 2;
                //  Ǎς݃TCY
                Inc(SumSize, LineSize);
                //  i(X)
                if (Counter mod PROGRESS_INTERVAL = 0) then CheckDoProgress(FileSize, SumSize);
                //  JEgAbv
                Inc(Counter);
            end;
            //  i
            CheckDoProgress(FileSize, SumSize);
            //  Î(fՂ?)
            FNoError := EOF(F);

        except
            on E:Exception do CheckDoMessage(E.Message);
        end;

    finally
        //  FindFirstŊmۂłJ
        FindClose(SearchRec);
        //  S}
        CloseFile(F);
        //  t@C[h߂
        FileMode := PreFileMode;
    end;

    //  n
    FDone := true;
    CheckDoFinished();
end;

(*
    ===========================================================================
    C^[lbgt@CǍXbh
    ===========================================================================
*)
type
    TNetLoaderThread = class(TLoaderThread)
    private
        FUrl        : string;
        FUserAgent  : string;
        FStream     : TMemoryStream;
    public
        constructor Create(AUrl, AUserAgent: string; AStream: TMemoryStream);
        procedure   Execute; override;
    end;

constructor TNetLoaderThread.Create(AUrl, AUserAgent: string; AStream: TMemoryStream);
begin
    FUrl := AUrl;
    FUserAgent := AUserAgent;
    FStream := AStream;
    inherited Create(true);
end;

procedure   TNetLoaderThread.Execute;
const
    PROGRESS_INTERVAL = 200;
var
    hSession: HINTERNET;
    hService: HINTERNET;
    lpBuffer: array[0..1024] of Char;
    dwBytesRead: Cardinal;
    dwFileSize, dwReserved: DWORD;
    Counter: integer;
begin
    //  O
    FDone := false;
    FNoError := false;
    Counter := 0;
    //  ǂݍݐ̃XgNA
    FStream.Clear;

    //  ZbVJ
    hSession := InternetOpen(PChar(FUserAgent), INTERNET_OPEN_TYPE_PRECONFIG,
                                nil, nil, 0);
    try
        //  Ă
        if Assigned(hSession) then
        begin
            CheckDoMessage('[  OK  ] InternetOpen(SESSION)');
            //  T[rXJ
            hService := InternetOpenUrl(hSession, PChar(FUrl), nil,
                                        0, INTERNET_FLAG_RELOAD, 0);
            try
                //  Ă
                if Assigned(hService) then
                begin
                    CheckDoMessage('[  OK  ] InternetOpenUrl(SERVICE) ' + FUrl);
                    //  t@CTCY擾
                    dwFileSize := SizeOf(FFullSize);
                    dwReserved := 0;
                    HttpQueryInfo(hService,
                                    HTTP_QUERY_CONTENT_LENGTH or HTTP_QUERY_FLAG_NUMBER,
                                    @FFullSize, dwFileSize, dwReserved);
                    //  ǂݍ݃t@CTCY
                    FLoadedSize := 0;
                    //  ʒm
                    CheckDoProgress(FFullSize, FLoadedSize);
                    while not Terminated do
                    begin
                        //  
                        FillChar(lpBuffer, SizeOf(lpBuffer), #0);
                        //  ǂݍ
                        InternetReadFile(hService, @lpBuffer,
                                            SizeOf(lpBuffer), dwBytesRead);
                        //  0oCgǂ񂾁Sǂ񂾂I
                        if dwBytesRead = 0 then Break;
                        //  ǂݍ񂾕Xg[֏
                        FStream.Write(lpBuffer,dwBytesRead);
                        //  ǂݍ񂾃TCYJEg
                        Inc(FLoadedSize, dwBytesRead);
                        //  i(X)
                        if (Counter mod PROGRESS_INTERVAL = 0) then CheckDoProgress(FFullSize, FLoadedSize);
                        //  JEgAbv
                        Inc(Counter);
                    end;
                    //  Î(fՂ?)
                    FNoError := (not Terminated);
                    //  ǂݎʒu擪ɎĂ
                    FStream.Position := 0;
                end
                else
                begin
                    CheckDoMessage('[FAILED] InternetOpenUrl(SERVICE)');
                end;
            finally
                //  T[rX
                InternetCloseHandle(hService);
                CheckDoMessage('[  OK  ] InternetCloseHandle(SERVICE)');
            end;
        end
        else
        begin
            CheckDoMessage('[FAILED] InternetOpen(SESSION)');
        end;
    finally
        //  ZbV
        InternetCloseHandle(hSession);
        CheckDoMessage('[  OK  ] InternetCloseHandle(SESSION)');
    end;

    //  n
    FDone := true;
    CheckDoFinished();
end;

{$R *.dfm}

(*
    ===========================================================================
    [Jt@CǍC^[tF[X
    ===========================================================================
*)
function    LoadFromLocalFile(AFileName: string; AStrings: TStrings): Boolean;
var
    LForm: TLoadFileForm;
    Loader: TLoaderThread;
    FullName, DispName: string;
begin
    //  tH[쐬
    LForm := TLoadFileForm.Create(Application);
    //  t@C\
    FullName := ExpandUNCFileName(AFileName);
    DispName := MinimizeName(FullName, LForm.LblFileName.Canvas, LForm.LblFileName.Width);
    LForm.LblFileName.Caption := DispName;
    //  Xbh쐬
    Loader := TLocalLoaderThread.Create(AFileName, AStrings);
    //  󋵒ʒmCxg蓖
    Loader.OnProgress := LForm.OnProgress;
    //  IʒmCxg蓖
    Loader.OnFinished := LForm.OnFinished;
    //  Xbh蓖
    LForm.ChildThread := Loader;
    //  XbhJn
    Loader.Resume;
    //  tH[\
    LForm.ShowModal;
    //  ߂l
    Result := Loader.FNoError;
    //  Xbh
    Loader.Free;
    //  tH[
    LForm.Free;
end;

(*
    ===========================================================================
    C^[lbgt@CǍC^[tF[X
    ===========================================================================
*)
function    LoadFromNetFile(AUrl, AUserAgent: string; AStream: TMemoryStream): Boolean;
var
    LForm: TLoadFileForm;
    Loader: TLoaderThread;
begin
    //  tH[쐬
    LForm := TLoadFileForm.Create(Application);
    //  t@C\
    LForm.LblFileName.Caption := AUrl;
    LForm.LblFileName.Repaint;
    //  Xbh쐬
    Loader := TNetLoaderThread.Create(AUrl, AUserAgent, AStream);
    //  󋵒ʒmCxg蓖
    Loader.OnProgress := LForm.OnProgress;
    //  IʒmCxg蓖
    Loader.OnFinished := LForm.OnFinished;
    //  Xbh蓖
    LForm.ChildThread := Loader;
    //  XbhJn
    Loader.Resume;
    //  tH[\
    LForm.ShowModal;
    //  ߂l
    Result := Loader.FNoError;
    //  Xbh
    Loader.Free;
    //  tH[
    LForm.Free;
end;

(*
    ===========================================================================
    tH[RXgN^
    ===========================================================================
*)
procedure TLoadFileForm.FormCreate(Sender: TObject);
begin
  inherited;
    ImgIcon.Picture.Icon.Assign(Application.Icon);
end;

(*
    ===========================================================================
    LZ{^
    ===========================================================================
*)
procedure TLoadFileForm.BtnAbortClick(Sender: TObject);
begin
    if (FChildThread.Suspended) then FChildThread.Resume;
    FChildThread.Terminate;
end;

(*
    ===========================================================================
    ꎞ~{^
    ===========================================================================
*)
procedure TLoadFileForm.BtnPauseClick(Sender: TObject);
begin
    if (FChildThread.Suspended) then FChildThread.Resume
                                else FChildThread.Suspend;
end;

(*
    ===========================================================================
    󋵒ʒm
    ===========================================================================
*)
procedure   TLoadFileForm.OnProgress(const AFullSize, ALoadedSize: integer);
const
    KILO = 1024;
    MEGA = KILO * KILO;
var
    Ticks: Cardinal;
    AvrSpeed: double;
    UnLoadedSize, WantTime: integer;
begin
    //  Ǎ
    if (ALoadedSize <> 0) then
    begin
        Gauge.Progress := ALoadedSize;
        //  ܂łɌo߂~b
        Ticks := GetTickCount - FStartCount;
        if (Ticks > 0) then
        begin
            //  1~b̃_E[hoCg
            AvrSpeed := ALoadedSize / Ticks;
            //  coCg
            UnLoadedSize := AFullSize - ALoadedSize;
            if (UnLoadedSize < 0) then UnLoadedSize := 0;
            //  coCĝɂ肻Ȏ
            WantTime := Round(UnLoadedSize / AvrSpeed);
            //  x\
            LblSpeed.Caption := Format('%5.3f[MB/s]', [AvrSpeed * 1000 / MEGA]);
            //  oߎԕ\
            LblTime01.Caption := MilliSecToTimeStr(Ticks);
            LblTime02.Caption := MilliSecToTimeStr(WantTime);
        end;
    end
    else
    //  ǍJn
    begin
        FStartCount := GetTickCount;
        Gauge.MaxValue := AFullSize;
        LblSpeed.Caption := '-----[MB/s]';
        LblSize02.Caption := Format('%5.3f[MB]', [AFullSize / MEGA]);
    end;
    LblSize01.Caption := Format('%5.3f[MB]', [ALoadedSize / MEGA]);
    LblSize01.Repaint;
    LblTime01.Repaint;
    LblTime02.Repaint;
    LblSpeed.Repaint;
end;

(*
    ===========================================================================
    Iʒm
    ===========================================================================
*)
procedure   TLoadFileForm.OnFinished();
begin
    Self.Close;
end;

(*
    ===========================================================================
    ESC ŏIuȂv(ptH[̂𖳌)
    ===========================================================================
*)
procedure TLoadFileForm.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
    ;
end;

end.


