(*
    ===========================================================================

    _Base.pas

    ---------------------------------------------------------------------------

    2003/12/02  쐬

    ===========================================================================
*)
unit _Base;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, Menus;

type
  T_BaseForm = class(TForm)
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
  private
  protected
    Bitmap  : TBitmap;        //  _uobt@pBitmap
  public
    { Public 錾 }
  end;

var
  _BaseForm: T_BaseForm;

implementation

{$R *.dfm}

(*
    ===========================================================================
    ESCŕ
    ===========================================================================
*)
procedure T_BaseForm.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
    if (Key = VK_ESCAPE) then Self.Close();
end;

(*
    ===========================================================================
    tH[RXgN^
    ===========================================================================
*)
procedure T_BaseForm.FormCreate(Sender: TObject);
begin
    Self.Caption := Application.Title + '-' + Self.Caption;

    //  _uobt@pBitmap쐬
    Bitmap := TBitmap.Create;
    Bitmap.Width := Screen.Width;
    Bitmap.Height := Screen.Height;
    Bitmap.Canvas.Font.Assign(Self.Font);
end;

(*
    ===========================================================================
    tH[fXgN^
    ===========================================================================
*)
procedure T_BaseForm.FormDestroy(Sender: TObject);
begin
    //  _uobt@pBitmapj
    Bitmap.Free;
    Bitmap := nil;
end;

end.

