unit memdbg;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, _Base, StdCtrls, ExtCtrls;

type
  TMemDebugForm = class(T_BaseForm)
    Timer1: TTimer;
    ListBox1: TListBox;
    procedure Timer1Timer(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormHide(Sender: TObject);
  private
    { Private 錾 }
  public
    { Public 錾 }
  end;

var
  MemDebugForm: TMemDebugForm;

implementation

{$R *.dfm}

(*
    =================================================================
    Subject: [Delphi:56760] Iz񂪊JȂ
    =================================================================
*)
procedure TMemDebugForm.Timer1Timer(Sender: TObject);
const
    MEGA = 1024 * 1024;
var
    MemoryStatus:TMemoryStatus;
    MemCount,MemSize: integer;
begin
    MemCount := AllocMemCount;
    MemSize  := AllocMemSize;
    MemoryStatus.dwLength:= SizeOf(MemoryStatus);
    GlobalMemoryStatus(MemoryStatus);
    ListBox1.Clear;
    with MemoryStatus, ListBox1.Items do
    begin
        Add(Format('Imې:%d'      , [MemCount]));
        Add(Format('Imۗ:%d'      , [MemSize]));
        Add(Format('@gp̃:%d[%%]'  , [dwMemoryLoad]));
        Add(Format('@@@:%.2f[MB]', [dwTotalPhys / MEGA]));
        Add(Format('@@󕨗:%.2f[MB]', [dwAvailPhys / MEGA]));
        Add(Format('@y[Wt@C:%.2f[MB]', [dwTotalPageFile / MEGA]));
        Add(Format('y[Wt@C:%.2f[MB]', [dwAvailPageFile / MEGA]));
        Add(Format('@[U[:%.2f[MB]', [dwTotalVirtual / MEGA]));
        Add(Format('󃆁[U[:%.2f[MB]', [dwAvailVirtual / MEGA]));
    end;
end;

procedure TMemDebugForm.FormShow(Sender: TObject);
begin
  inherited;
    Timer1.Enabled := true;
end;

procedure TMemDebugForm.FormHide(Sender: TObject);
begin
  inherited;
    Timer1.Enabled := false;
end;

end.

